#if !defined(TREE_H)
#define TREE_H


/* includes *******************************************************************/

#include "TreeOpener.h"


/* part from original file ****************************************************/

#include <w3c/svg/SVGElement.hpp>
#include <w3c/svg/SVGGElement.hpp>
#include <w3c/svg/SVGUseElement.hpp>
#include <w3c/svg/SVGRectElement.hpp>

#include <hsm/interaction/Protocol.h>
#include <hsm/svgl/SVGLWindow.h>
#include <hsm/svgl/SVGLBehaviour.h>


/* foraward declarations ******************************************************/

class Tree;


/* Node class definition ******************************************************/

class Node : public hsm::SVGLBehaviour {
	static const hsm::SVGLBehaviour::Factory::Register< Node > registration;

public :
	Tree *parent;

public :
	Node(svg::SVGElement *e, hsm::SVGLWindow *w);
	virtual ~Node();
	
	virtual unsigned int getHeight();
	void translateAllBrothers(int dy);

private :
	void translateBrothers(int dy);
};


/* Tree class definition ******************************************************/

class TreeOpener;

class Tree : public Node {
	friend class TreeOpener;

private :
	svg::SVGRectElement *background;
	svg::SVGUseElement *handle;
	svg::SVGGElement *content;

	static const hsm::SVGLBehaviour::Factory::Register< Tree > registration;

public : 
	bool isOpen;
	
public :
	Tree(svg::SVGElement *e, hsm::SVGLWindow *w);

	virtual unsigned int getHeight();
	void resizeBackground(int dHeight);
	
	void open();
	void close();

	void add(svg::SVGElement *e, unsigned int p);
	void remove(svg::SVGElement *e);
};


#endif // !defined(TREE_H)
