////////////////////////////////////////////////////////////////////////////////
// File    : PlugIn.h
// Content : functions dealing with dynamic library loading
// History : 11-Jan-2004 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/// \file PlugIn.h
/// Functions dealing with dynamic library loading.


#if !defined(HSM_PLUGIN_H)
#define HSM_PLUGIN_H


/* includes *******************************************************************/

#include <string>


namespace hsm {

/* forward declarations *******************************************************/

	class EventHandler;
	

	/// contains functions to manage plugins
	namespace plugin {
		
/* functions ******************************************************************/
		
		/// loads a plugin
		/// the plugins are loaded from the folder specified in environnement
		/// variable HSM_PLUGINS_PATH
		/// \param name the name of the component
		bool load(const std::string &name);
		

	} // namespace plugin

} // namespace hsm


#endif // !defined(HSM_PLUGIN_H)