////////////////////////////////////////////////////////////////////////////////
// File    : Alert.WIN32.cpp
// Content : a class for selectable alert
// History : 13-Feb-2003 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



/* includes *******************************************************************/

#include <Alert.h>

#define _WIN32_WINNT 0x0400
#include <windows.h>


namespace hsm {

/* Alert class implementation**************************************************/

	Alert::Alert() : Selectable() {
		fd = CreateEvent(0, FALSE, FALSE, 0);
		registerFd();
	}
	
	Alert::~Alert() {
		reset();
		close(fd);
	}
		
	void Alert::set() {
		SetEvent(fd);
	}

	void Alert::reset() {
		ResetEvent(fd);
	}


} // namespace hsm
