////////////////////////////////////////////////////////////////////////////////
// File    : Selectable.cpp
// Content : base class for selectable objects
// History : 13-Feb-2003 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* includes *******************************************************************/

#include <Selectable.h>


namespace hsm {

/* static data initialisation *************************************************/

	Selectable::Map Selectable::selectableMap;


/* Selectable class implementation ********************************************/

	Selectable::Selectable(file::Descriptor id /* = 0 */) : fd(id) {
		registerFd();
	}
	
	Selectable::~Selectable() {
		selectableMap.erase(fd);
	}
		
	Selectable::operator file::Descriptor() const {
		return fd;
	}
	
	Selectable *Selectable::get(const file::Descriptor &id) {
		return selectableMap[id];
	}

	void Selectable::registerFd() {
		selectableMap[fd] = this;
	}


} // namespace hsm