////////////////////////////////////////////////////////////////////////////////
// File    : ThreadLoop.WIN32.cpp
// Content : a thread based classes
// History : 
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



/* includes *******************************************************************/

#include <ThreadLoop.h>


namespace hsm {

/* ThreadLoop::os struct implementation ***************************************/

	DWORD WINAPI ThreadLoop::os::threadFn(LPVOID tl) {
		ThreadLoop *threadLoop = reinterpret_cast< ThreadLoop * >(tl);
		threadLoop->loop();
		return 0;
	}

	ThreadLoop::os::ThreadId ThreadLoop::os::create(ThreadLoop *tl) {
		Id id;
		CreateThread(0, 0, threadFn, (void *)(tl), 0, &id);
		return id;
	}

	void ThreadLoop::os::waitFor(Id id) {
		typedef DWORD (__stdcall*pNOT)(HANDLE*, DWORD, void*, void*);
		HANDLE hThread = 0;
		DWORD s1[] = {0x18, 0, 0, 0, 0, 0}; DWORD s2[] = {0, i};
		HMODULE hLib = LoadLibrary("ntdll.dll");
		pNOT pfn = (pNOT)GetProcAddress(hLib, "NtOpenThread");
		pfn(&hThread, SYNCHRONIZE, s1, s2);
		FreeLibrary(hLib);
		WaitForSingleObject(hThread, INFINITE);
		CloseHandle(hThread);
	}

	ThreadLoop::os::Id ThreadLoop::os::self() {
		return GetCurrentThreadId();
	}


} // namespace hsm
