////////////////////////////////////////////////////////////////////////////////
// File    : Timer.MACOSX.cpp
// Content : a timer class
// History : 21-Dec-2001 - [rb] creation
//           18-Jan-2002 - [rb] [BugFix] MacOSX version post an empty event
//                         when a timer fires. Thus a loop ending with a timer
//                         and waiting for systems event can actually end
//                         without a system event.
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* includes *******************************************************************/

#include <Timer.h>

#include <hsm/util/Functor.h>


namespace hsm {

/* Timer::os struct implementation ********************************************/

		void Timer::os::timerCb(Id timerId, void *) {
			Timer *timer = Timer::timerMap[timerId];
			timer->fire();

			EventRef event;
			CreateEvent(0, 'hsm:', 0, 0, kEventAttributeUserEvent, &event);
			PostEventToQueue(GetMainEventQueue(), event, kEventPriorityStandard);
		}

		Timer::os::Id Timer::os::installTimer(unsigned int ms) {
			Id id;
			InstallEventLoopTimer(GetMainEventLoop(), ms * kEventDurationMillisecond, 0, NewEventLoopTimerUPP(timerCb), 0, &id);
			return id;
		}

		void Timer::os::removeTimer(Id id) {
			RemoveEventLoopTimer(id);
		}


} // namespace hsm
