////////////////////////////////////////////////////////////////////////////////
// File    : Timer.WIN32.cpp
// Content : a timer class
// History : 21-Dec-2001 - [rb] creation
//           03-Jul-2002 - [rb] [BugFix] under WinNT, timer set with a 0 delay
//                         repeats.
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* includes *******************************************************************/

#include <Timer.h>

#include <hsm/util/Functor.h>


namespace hsm {

/* Timer::os struct implementation ********************************************/

		void CALLBACK Timer::os::timerCb(HWND, UINT, UINT timerId, DWORD) {
			Timer *timer = Timer::timerMap[timerId];
			timer->fire();
		}

		Timer::os::Id Timer::os::installTimer(unsigned int ms) {
			return SetTimer(0, 0, ms, timerCb);
		}

		void Timer::os::removeTimer(Id id) {
			KillTimer(0, id);
		}


} // namespace hsm
