////////////////////////////////////////////////////////////////////////////////
// File    : Keyboard.WIN32.cpp
// Content : libhsm system keyboard plugin
// History : 13-Aug-2002 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// ToDo ////////////////////////////////////////////////////////////////////////
// - implement WIN32 version


/* includes *******************************************************************/

#include <Keyboard.h>

#include <hsm/util/Debug.h>
#include <hsm/component/ButtonPad.h>
#include <hsm/system/window/Window.h>


namespace hsm {

/* Keyboard instance **********************************************************/

	const Keyboard Keyboard::instance;


/* Keyboard implementation ****************************************************/

	LONG WINAPI Keyboard::handler(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam) {
		switch (iMessage) {
/*
		case WM_KEYDOWN :
			break;
*/
	 	default:
			return 0;
		}
		return 0;
	}


	Keyboard::Keyboard() : impl::Component< EventHandler >(Keyboard) {
		HSM_PRINT(1, "[Keyboard::Keyboard()]")

		nbEvents = 0;
		eventSpec = new Window::os::EventSpec[nbEvents];

		add(keys = new ButtonPad("keys", ButtonPad::MAX + 1));
		add(modifiers = new ButtonPad("modifiers", ButtonPad::CTRL + 1));
		
		hsm::repository::add(this);
	}

	Keyboard::~Keyboard() {
		HSM_PRINT(1, "[Keyboard::~Keyboard()]")
		hsm::repository::remove(this);
		delete[] eventSpec;
	}

	Window::os::Handler *Keyboard::getHandler() const {
		return handler;
	}


} // namespace hsm
