////////////////////////////////////////////////////////////////////////////////
// File    : Listener.cpp
// Content : hsm listener component
// History : 25-Oct-2001 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2004  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* includes *******************************************************************/

#include <Listener.h>

#include <hsm/core/Event.h>
#include <hsm/util/Debug.h>


namespace hsm {

/* Listener instance **********************************************************/

	const Listener Listener::instance;
	

/* Listener implementation ****************************************************/

	Listener::Listener() : impl::Component< >("Listener") {
		hsm::repository::add(this);
	}

	Listener::~Listener()  {
		hsm::repository::remove(this);
	}
	
	void Listener::process(const Event &event) {
		HSM_OUTPUT(componentId << " received : " << event);
	}


} // namespace hsm
