////////////////////////////////////////////////////////////////////////////////
// File    : test-Timer.cpp
// Content : a test for hsm Timer
// History : 17-Jan-2002 - [rb] creation
////////////////////////////////////////////////////////////////////////////////

/*
    Copyright (C) 2003  Renaud Blanch <rb.hsm@laposte.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


/* includes *******************************************************************/

#include <cstdlib>
#include <iostream>
using namespace std;

#include <hsm/system/time/Timer.h>
#include <hsm/system/event/EventLoop.h>
#include <hsm/util/Functor.h>


/* globals ********************************************************************/

void timer(void *n) { cout << "t" << int(n) << " fired." << endl; }


/* handle quit ****************************************************************/

void quitHandler() {
	cout << endl << "bye." << endl;
}


/* main ***********************************************************************/

int main(int argc, const char *argv[]) {
	cout << "test-Timer - a program to test the hsm::Timer class." << endl << endl;
	atexit(quitHandler);

	hsm::Functor *f = hsm::Functor::create(timer);

	cout << "setting t0 now," << endl;
	hsm::Timer *timer0 = new hsm::Timer(0, f, (void *)(0));
	cout << "setting t1 in 3 sec," << endl;
	hsm::Timer *timer1 = new hsm::Timer(3000, f, (void *)(1));
	cout << "setting t2 in 3 sec," << endl;
	hsm::Timer *timer2 = new hsm::Timer(3000, f, (void *)(2));
	cout << "setting t3 in 4 sec." << endl;
	hsm::Timer *timer3 = new hsm::Timer(4000, f, (void *)(3));
	cout << "setting t4 in 5 sec." << endl;
	hsm::Timer *timer4 = new hsm::Timer(5000, f, (void *)(4));
	cout << "removing t3." << endl;
	timer3->stop();

	cout << "setting ending timer in 7 sec." << endl << endl;
	hsm::Timer wait(7000);
	while(wait.hasFired() != true) {
		hsm::eventloop::step();
	}
	
	delete timer0;
	delete timer1;
	delete timer2;
	delete timer3;
	delete timer4;
	delete f;

	return EXIT_SUCCESS;
}
